package jp.co.celestee.ai.interfaces.body;

import jp.co.celestee.ai.core.signal.PleasureIF;
import jp.co.celestee.ai.interfaces.AbstractSubstance;
import jp.co.celestee.ai.interfaces.body.pleasure.Palate;
import jp.co.celestee.ai.interfaces.input.DefaultDataCooperationSignal;
import jp.co.celestee.ai.interfaces.input.DefaultEnvironmentSensibleSignal;
import jp.co.celestee.external.rule.RuleDataIF;
import jp.co.celestee.external.rule.dinamic.DynamicRuleAccessorIF;
import jp.co.celestee.external.rule.dinamic.DynamicRuleData;

public class BodySubstance extends AbstractSubstance implements DynamicRuleAccessorIF{

	private static BodySubstance subInstance = new BodySubstance();
	
	private BodySubstance() {}
	
	public static BodySubstance getInstance() {
		return subInstance;
	}

	@Override
	public void inputDynamic(DynamicRuleData ruleData) {
		inputDataFromRule(ruleData);
	}

	/**
	 * [IFւ̓
	 */
	@Override
	public void inputFromRule(RuleDataIF ruleData, Signals signals) {
		DynamicRuleData dynamicRuleData = (DynamicRuleData)ruleData;

		//IFŃf[^ϊ
		signals.setDataCooperationSignal(BodyDataConverter.change(dynamicRuleData));

		BodySignalData data = ((BodySignalData)signals.getDataCooperationSignal().getSignalData());
		if(data.getPain() == PleasureIF.PLEASURE_LEVEL) {
			DefaultEnvironmentSensibleSignal esSignal = new DefaultEnvironmentSensibleSignal();
			esSignal.setElectricPotential(signals.getDataCooperationSignal().getElectricPotential());
			signals.setEnvironmentSensibleSignal(esSignal);
			
			System.out.println("!!! y擾 !!!");
			
			//yf[^̐ݒ
			Palate pleasure = new Palate(1, 0, 0, 0, 0);
			pleasure.setPleasureLevel(PleasureIF.PLEASURE_LEVEL);
			esSignal.setPleasure(pleasure);
		}
		else if(data.getPain() == PleasureIF.DISPLEASURE_LEVEL) {
			DefaultEnvironmentSensibleSignal esSignal = new DefaultEnvironmentSensibleSignal();
			esSignal.setElectricPotential(signals.getDataCooperationSignal().getElectricPotential());
			signals.setEnvironmentSensibleSignal(esSignal);
			
			System.out.println("!!! s擾 !!!");
			
			//sf[^̐ݒ
			Palate pleasure = new Palate(0, 0, 0, 1, 0);
			pleasure.setPleasureLevel(PleasureIF.DISPLEASURE_LEVEL);
			esSignal.setPleasure(pleasure);
		}

	}

	/**
	 * AI̓
	 */
	@Override
	public void inputFromAI(Object aiData, Signals signals) {
		signals.setDataCooperationSignal((DefaultDataCooperationSignal)aiData);
		
		System.out.println("@AI @Body@@Rule");
	}

	/**
	 * C
	 * I~̒͂ōs
	 */
	@Override
	public void process(Signals signals) {

	}

	/**
	 * [ւ̏o
	 */
	@Override
	public void outputToRule(Signals signals) {
	}
	
}
