package jp.co.celestee.ai.interfaces.eye;

import jp.co.celestee.ai.core.signal.SignalDataIF;
import jp.co.celestee.ai.interfaces.image.ImageOutputId;
import jp.co.celestee.ai.interfaces.image.ImageSubstance;
import jp.co.celestee.ai.interfaces.output.AbstractOutputId;
import jp.co.celestee.ai.interfaces.output.OutputGroupIF;

/**
 * 摜_̓ID
 * @author celestee
 *
 */
public class EyeOutputId extends AbstractOutputId  implements OutputGroupIF{

	private static final long serialVersionUID = 1L;

	private static final Class<?> _triggerClass = EyeOutputTrigger.class;
	
	private static final Class<?> _signalDataClass = EyeSignalData.class;

	private static final Class<?> _groupClass = ImageOutputId.class;

	@Override
	public Class<?> getTriggerClass() {
		return _triggerClass;
	}

	@Override
	public Class<?> getSignalDataClass() {
		return _signalDataClass;
	}
	
	@Override
	public Class<?> getGroupClass() {
		return _groupClass;
	}

	@Override
	public SignalDataIF simulate() {
		ImageSubstance imageSubstance = ImageSubstance.getSimulateInstance();
		imageSubstance.changeModeAdd();
		return imageSubstance.getRetinaImage();
	}

	@Override
	public boolean equals(Object target) {
		boolean b = super.equals(target);
		if(b == false) return b;
		
		if(target == null) return false;

		if(target instanceof EyeOutputId) {
			return true;
		}
		
		return false;
	}

	@Override
	public String getSupposingItSaysInMansWords() {
		return "eye";
	}

}
