package jp.co.celestee.ai.interfaces.image;

import jp.co.celestee.ai.interfaces.input.DefaultDataCooperationSignal;
import jp.co.celestee.external.rule.light.LightRuleData;
import jp.co.celestee.external.rule.light.LightRulePartsData;

public class ImageDataConverter {

	/**
	 * [̎hf[^AI̓dCM֕ϊ܂B<br>
	 * [́A1̌f[^ɁA}X̃|SĂ܂AW̎oɂāAf[^𒊏ۉi1}X̃|SjĂ܂B
	 * ܂A̒ۉ́A{Tvł͊ȈՓIɎĂ܂Bi{́AȑgD}bvȂǂŎ镔j
	 * @param ruleData
	 * @return
	 */
	public static DefaultDataCooperationSignal change(LightRuleData ruleData) {
		
		LightRulePartsData partsData = ruleData.getFirstLightRulePartsData();
		
		if(partsData == null) {
			throw new UnsupportedOperationException();
		}
		
		ImageColor color = new ImageColor(
				partsData.getColor().getRed(), partsData.getColor().getGreen(), partsData.getColor().getBlue(), partsData.getColorName());
		ImagePolygon polygon = new ImagePolygon(
				partsData.getXpoints(), partsData.getYpoints(), partsData.getXpoints().length, partsData.getAddX(), partsData.getAddY(), partsData.getPolygonString());
		
		ImageSignalData isData = new ImageSignalData(color, polygon, ruleData.getPointList());
		
		DefaultDataCooperationSignal signal = new DefaultDataCooperationSignal();
		signal.setElectricPotential(ruleData.getPotential());
		signal.setSignalData(isData);

		return signal;
	}

}
