package jp.co.celestee.ai.interfaces.image;

import jp.co.celestee.ai.core.signal.SignalDataIF;
import jp.co.celestee.ai.external.human.HumanWordsIF;
import jp.co.celestee.ai.interfaces.output.AbstractOutputId;
import jp.co.celestee.ai.interfaces.output.DataSyntheticIF;
import jp.co.celestee.ai.interfaces.output.OutputGroupIF;

/**
 * 摜p̏oID
 * @author celestee
 *
 */
public class ImageOutputId extends AbstractOutputId implements DataSyntheticIF, OutputGroupIF{

	private static final long serialVersionUID = 1L;

	private static final Class<?> _triggerClass = ImageOutputTrigger.class;
	
	private static final Class<?> _signalDataClass = ImageSignalData.class;

	private static final Class<?> _groupClass = ImageOutputId.class;

	@Override
	public Class<?> getTriggerClass() {
		return _triggerClass;
	}

	@Override
	public Class<?> getSignalDataClass() {
		return _signalDataClass;
	}
	
	@Override
	public Class<?> getGroupClass() {
		return _groupClass;
	}

	@Override
	public void beforeSimulate() {
		ImageSubstance imageSubstance = ImageSubstance.getSimulateInstance();
		imageSubstance.changeModeNormal();
	}
	
	@Override
	public SignalDataIF simulate() {
		ImageSubstance imageSubstance = ImageSubstance.getSimulateInstance();
		imageSubstance.chageMemory((ImageSignalData)getInnerOption());
		return imageSubstance.getRetinaImage().copyInstance();
	}

	@Override
	public boolean equals(Object target) {
		boolean b = super.equals(target);
		if(b == false) return b;
		
		if(target == null) return false;

		if(target instanceof ImageOutputId) {
			return true;
		}
		
		return false;
	}

	@Override
	public String getSupposingItSaysInMansWords() {
		return "image ( " + ((HumanWordsIF)getInnerOption()).getSupposingItSaysInMansWords() + " )";
	}

}
