package jp.co.celestee.ai.interfaces.status;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JComponent;

@SuppressWarnings("serial")
public class JRetina extends JComponent{

	private int squareWide = 30;					// }Xڂ̕

	private Image  offScreenImg;					// ItXN[
	private Graphics grf;
   	
	private int width = squareWide * 5;
	private int height = squareWide * 2;
	
	private Color _color = null;
	private Polygon _polygon = null;
	private List<Point> _pointList = null;							//~J̐
	private int _abstCount = 0;
	private int _startY = 0;						//Ԗ̎_ʒu
	
	public JRetina() {
		init();
	}
	
	public void init(){
		// ItXN[̐ݒ
		offScreenImg = getImage();
		grf = offScreenImg.getGraphics();

	}
	
	public void setColor(Color color) {
		_color = color;
	}

	public void setPolygon(Polygon polygon) {
		_polygon = polygon;
	}
	
	public void setCountList(List<Point> pointList) {
		_pointList = pointList;
	}
	
	public void addCountList(Point point) {
		if(_pointList == null) {
			_pointList = new ArrayList<Point>();
		}
		_pointList.add(point);
	}
	
	public void setStartY(int y) {
		_startY = y * squareWide;
	}

	public int getWidth() {
		return width;
	}

	public void setWidth(int width) {
		this.width = width;
	}

	public int getHeight() {
		return height;
	}

	public void setHeight(int height) {
		this.height = height;
	}
	
	public int getAbstCount() {
		return _abstCount;
	}
	
	public void setAbstCount(int abstCount) {
		this._abstCount = abstCount;
	}

	public void paint(Graphics g) {
		update(g);
	}

	public void update(Graphics g){

		//MAP̕`
		grf.setColor(Color.darkGray);
		grf.fillRect(0, 0, width, height);
		grf.setColor(Color.white);
		grf.fillRect(0, _startY, width, height);
		
		//~J̕`
		int xx = 0;
		int yy = 0;
		if(_pointList != null && _pointList.size() > 0) {
			for(Point xyPoint : _pointList){
				yy = xyPoint.y * squareWide;
				xx = xyPoint.x * squareWide;
					
				grf.translate(xx, yy);
				if(_color != null) {
					grf.setColor(_color);
				}
				if(_polygon != null) {
					grf.fillPolygon(_polygon);
				}
				grf.translate(-xx, -yy);
			}
		} else {
			//ۉ̃C[Wł邱Ƃ𗘗p҂ւ킩悤ɕ\
			if(_color != null) {
				grf.setColor(_color);
			} else {
				grf.setColor(Color.black);
			}
			grf.drawString("Abstract Image. count=" + _abstCount, 0, 16);
		}
		
		// ItXN[̃C[WꋓɎۂ̕\̈ɕ`
		g.drawImage(offScreenImg, 0, 0, this);	

	}

	BufferedImage getImage() {
		
		BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
		Graphics g = bi.createGraphics();
		paintComponent(g);
		return bi;
	}
	
	void setImage(Image img) {
		offScreenImg = img;
		repaint();
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		if(offScreenImg != null){
			int w = offScreenImg.getWidth(this);
			int h = offScreenImg.getHeight(this);
			if(w != width || h != height){
				width = w;
				height = h;
				this.setPreferredSize(new Dimension(width, height));
			}
			g.drawImage(offScreenImg, 0, 0, this);
		}
	}
	
}
