package jp.co.celestee.ai.interfaces.status;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import jp.co.celestee.ai.core.AICoreConst;
import jp.co.celestee.ai.core.embed.DesireEmbeder;
import jp.co.celestee.ai.core.embed.PhysicalDesirePreInstaller;
import jp.co.celestee.ai.core.embed.RunningEducationModeException;
import jp.co.celestee.ai.core.nerve.DesireNerveIF;
import jp.co.celestee.ai.core.nerve.NerveIF;
import jp.co.celestee.ai.external.debug.DevelopHelper;
import jp.co.celestee.ai.interfaces.MemoryControler;
import jp.co.celestee.ai.interfaces.body.id.BodyWalkId;
import jp.co.celestee.ai.interfaces.characterin.CharacterInOutputId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutEightId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutEqualsId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutFiveId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutFourId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutNineId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutOneId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutOutputId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutSevenId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutSixId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutTenId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutThreeId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutTwoId;
import jp.co.celestee.ai.interfaces.constant.PhysicalDesireConst;
import jp.co.celestee.ai.interfaces.eye.EyeOutputId;
import jp.co.celestee.ai.interfaces.image.ImageOutputId;
import jp.co.celestee.ai.interfaces.image.ImageSignalData;
import jp.co.celestee.ai.interfaces.image.ImageSubstance;
import jp.co.celestee.ai.interfaces.image.PolygonAbstractSample;
import jp.co.celestee.ai.interfaces.output.GroupingOutputId;
import jp.co.celestee.ai.interfaces.output.OutputTriggerIF;
import jp.co.celestee.external.object.LightGenerator;

@SuppressWarnings("serial")
public class JStatusFrame extends JFrame implements ActionListener{

	//TODO [Xfalseɐݒ肷
	private static final boolean bDebug = true;
	
	private static JTextArea MAX_DESIRE_AREA = null;
	private static JTextArea VIEW_PLAN_AREA = null;
	private static JTextArea STATUS_AREA = null;
	private static JTextArea TEMPT_AREA = null;
	private static JTextArea SIGNAL_AREA = null;
	private static JTextArea PLAN_AREA = null;
	private static JTextArea PHYSICAL_RECORD_AREA = null;
	private static JTextArea LOGICAL_RECORD_AREA = null;
	private static JTextArea PLEASURE_AREA = null;
	
	private static JTextField TEMPT_NERVE_ID_FIELD = null;
	private static JTextField TEMPT_LEVEL_CHANGE_FIELD = null;
	private static JTextField COMMON_PLAN_REMOVE_FIELD = null;
	private static JTextField PLEASURE_REMOVE_FIELD = null;
	private static JTextField DESIRE_NERVE_REMOVE_FIELD = null;
	private static JTextField DESIRE_NERVE_EXEC_FIELD = null;
	private static JTextField OUTPUT_SOUND_FIELD = null;
	private static JTextField OUTPUT_SOUND_FIELD_T = null;
	private static JTextField OUTPUT_BODY_FIELD = null;
	private static JTextField OUTPUT_BODY_FIELD_T = null;
	private static JStatusMeter SIGNAL_METER = null;
	private static JStatusMeter ENERGY_METER = null;

	JButton outSoundButton = null;
	JButton outSoundButton_t = null;
	JButton outBodyButton = null;
	JButton outBodyButton_t = null;
	JButton outImageButton = null;
	JButton clearSignalButton = null;
	JButton clearPleasureHistoryButton = null;
	
	JCheckBox nerveCheck = null;
	JCheckBox desireCheck  = null;
	JCheckBox abstractDesireCheck  = null;
	JCheckBox physicalDesireCheck  = null;
	JCheckBox partsCheck = null;

	JCheckBox imageCheck = null;
	JCheckBox charInCheck = null;
	JCheckBox charOutCheck = null;
	JCheckBox eyesCheck = null;

	JCheckBox check0_0 = null;
	JCheckBox check1_0 = null;
	JCheckBox check2_0 = null;
	JCheckBox check3_0 = null;
	JCheckBox check4_0 = null;
	JCheckBox check0_1 = null;
	JCheckBox check1_1 = null;
	JCheckBox check2_1 = null;
	JCheckBox check3_1 = null;
	JCheckBox check4_1 = null;

	JButton temptChangeButton = null;
	JButton commonPlanRemoveButton = null;
	JButton pleasureRemoveButton = null;
	JButton desireNerveRemoveButton = null;
	JButton desireNerveExecButton = null;
	JButton saveMemoryButton = null;
	JButton loadMemoryButton = null;
	JButton recodeSignalButton = null;
	JButton stopRecodeButton = null;
	JButton startEducationButton = null;

	public JStatusFrame() {
		
		JPanel basePane = new JPanel();
		getContentPane().add(basePane);
		
		basePane.setLayout(new BoxLayout(basePane, BoxLayout.X_AXIS));
		basePane.setSize(500, 760);
		
		JPanel statusPane = new JPanel();
		statusPane.setLayout(new BoxLayout(statusPane, BoxLayout.Y_AXIS));
		statusPane.setSize(280, 760);
		basePane.add(statusPane);

		//AI֖ߍ񂾋@B擾\pl
		JPanel embedPane = new JPanel();
		embedPane.setLayout(new GridLayout(1, 3));
		embedPane.setSize(280, 760);
		statusPane.add(embedPane);

		JPanel embedPane2 = new JPanel();
		embedPane2.setLayout(new GridLayout(1, 3));
		embedPane2.setSize(280, 760);
		statusPane.add(embedPane2);

		JPanel embedModePane = new JPanel();
		embedModePane.setLayout(new GridLayout(1, 3));
		//embedModePane.setLayout(new BoxLayout(embedModePane, BoxLayout.X_AXIS));
		embedModePane.setSize(280, 760);
		statusPane.add(embedModePane);

		//AI View(abstracted)
		embedPane2.add(new JLabel("Abstracted Image"));
		JAbstractedImage abstractedImage = JAbstractedImage.getInstance();
		abstractedImage.setBorder(BorderFactory.createLoweredBevelBorder());
		abstractedImage.setPreferredSize(new Dimension(abstractedImage.getWidth(), abstractedImage.getHeight()));
		abstractedImage.setMaximumSize(new Dimension(abstractedImage.getWidth(), abstractedImage.getHeight()));
		abstractedImage.setMinimumSize(new Dimension(abstractedImage.getWidth(), abstractedImage.getHeight()));
		embedPane2.add(abstractedImage);

		JPanel outImageButtonPane = new JPanel();
		outImageButtonPane.setLayout(new BoxLayout(outImageButtonPane, BoxLayout.Y_AXIS));
		embedPane2.add(outImageButtonPane);

		//[hpl
		embedModePane.add(new JLabel("Mode select"));

		//Education mode
		JCheckBox educationCheck = new JCheckBox("Education mode", true);
		educationCheck.addActionListener(this);
		educationCheck.setActionCommand("educationCheck");
		embedModePane.add(educationCheck);
		
		//Pre-installation mode
		JCheckBox defaultModeCheck = new JCheckBox("Pre-installation mode", false);
		defaultModeCheck.addActionListener(this);
		defaultModeCheck.setActionCommand("preinstallCheck");
		embedModePane.add(defaultModeCheck);

		//Xe[^Xpl
		JTabbedPane tabbedpane = new JTabbedPane();
		statusPane.add(tabbedpane);
		
		//OtBJXe[^X
		JPanel statusGPanel = new JPanel();
		statusGPanel.setLayout(new BoxLayout(statusGPanel, BoxLayout.Y_AXIS));
		
		statusGPanel.add(new JLabel("[ Signal meter ]"));
		
		SIGNAL_METER = new JStatusMeter();
		SIGNAL_METER.setColor(Color.blue, new Color(200, 200, 255), Color.white);
		//SIGNAL_METER.setMinimumSize(new Dimension(400, 12));
		SIGNAL_METER.setMaximumSize(new Dimension(800, 12));
		statusGPanel.add(SIGNAL_METER);

		statusGPanel.add(new JLabel("[ Energy meter ]"));
		
		ENERGY_METER = new JStatusMeter();
		ENERGY_METER.setColor(Color.yellow, new Color(255, 255, 235), Color.black);
		//ENERGY_METER.setMinimumSize(new Dimension(400, 12));
		ENERGY_METER.setMaximumSize(new Dimension(800, 12));
		statusGPanel.add(ENERGY_METER);

		statusGPanel.add(new JLabel(" "));

		statusGPanel.add(new JLabel("[ save memory ]"));

		saveMemoryButton = new JButton("save memory");
		saveMemoryButton.setActionCommand("savememory");
		saveMemoryButton.setMaximumSize(new Dimension(170, 20));
		saveMemoryButton.addActionListener(this);
		statusGPanel.add(saveMemoryButton);
		
		statusGPanel.add(new JLabel("[ load memory ]"));

		loadMemoryButton = new JButton("load memory");
		loadMemoryButton.setActionCommand("loadmemory");
		loadMemoryButton.setMaximumSize(new Dimension(170, 20));
		loadMemoryButton.addActionListener(this);
		statusGPanel.add(loadMemoryButton);

		statusGPanel.add(new JLabel(" "));

		statusGPanel.add(new JLabel("[ recode signal ]"));

		recodeSignalButton = new JButton("recode signal");
		recodeSignalButton.setActionCommand("recodesignal");
		recodeSignalButton.setMaximumSize(new Dimension(170, 20));
		recodeSignalButton.addActionListener(this);
		statusGPanel.add(recodeSignalButton);
		
		statusGPanel.add(new JLabel("[ stop recode signal ]"));

		stopRecodeButton = new JButton("stop recode");
		stopRecodeButton.setActionCommand("stoprecode");
		stopRecodeButton.setMaximumSize(new Dimension(170, 20));
		stopRecodeButton.addActionListener(this);
		statusGPanel.add(stopRecodeButton);

		statusGPanel.add(new JLabel("[ education signal ]"));

		startEducationButton = new JButton("start education");
		startEducationButton.setActionCommand("starteducation");
		startEducationButton.setMaximumSize(new Dimension(170, 20));
		startEducationButton.addActionListener(this);
		statusGPanel.add(startEducationButton);

		tabbedpane.addTab("Status", statusGPanel);

		//R}h
		JPanel commandPanel = new JPanel();
		commandPanel.setLayout(new BoxLayout(commandPanel, BoxLayout.Y_AXIS));
		commandPanel.setMaximumSize(new Dimension(380, 20));
		tabbedpane.addTab("Command", commandPanel);
		
		commandPanel.add(new JLabel(" "));

		//
		JPanel commandPanel1 = new JPanel();
		commandPanel1.setLayout(new GridLayout(1, 3));
		commandPanel1.setMaximumSize(new Dimension(380, 20));
		commandPanel1.setSize(280, 20);
		commandPanel1.add(new JLabel("Desire Embed Command"));
		commandPanel.add(commandPanel1);
		JSeparator separator6 = new JSeparator(SwingConstants.HORIZONTAL);
		separator6.setMaximumSize(new Dimension(380, 10));
		commandPanel.add(separator6);

		JPanel commandPanel11 = new JPanel();
		commandPanel11.setLayout(new GridLayout(1, 3));
		commandPanel11.setMaximumSize(new Dimension(380, 20));
		commandPanel11.setSize(280, 20);
		commandPanel.add(commandPanel11);

		JPanel commandPanel2 = new JPanel();
		commandPanel2.setLayout(new GridLayout(1, 3));
		commandPanel2.setMaximumSize(new Dimension(380, 20));
		commandPanel2.setSize(280, 20);
		commandPanel.add(commandPanel2);

		commandPanel.add(new JLabel(" "));
		commandPanel.add(new JLabel(" "));

		//
		JPanel commandPanel3 = new JPanel();
		commandPanel3.setLayout(new GridLayout(1, 3));
		commandPanel3.setMaximumSize(new Dimension(380, 20));
		commandPanel3.setSize(280, 20);
		commandPanel3.add(new JLabel("Trigger Command"));
		commandPanel.add(commandPanel3);
		JSeparator separator7 = new JSeparator(SwingConstants.HORIZONTAL);
		separator7.setMaximumSize(new Dimension(380, 10));
		commandPanel.add(separator7);

		JPanel commandPanel31 = new JPanel();
		commandPanel31.setLayout(new GridLayout(1, 3));
		commandPanel31.setMaximumSize(new Dimension(380, 20));
		commandPanel31.setSize(280, 20);
		commandPanel31.add(new JLabel("Output Image Trigger"));
		commandPanel.add(commandPanel31);

		JPanel commandPanel4 = new JPanel();
		commandPanel4.setLayout(new GridLayout(2, 5));
		commandPanel4.setMaximumSize(new Dimension(380, 40));
		commandPanel4.setSize(280, 40);
		commandPanel.add(commandPanel4);

		JPanel commandPanel5 = new JPanel();
		commandPanel5.setLayout(new GridLayout(1, 3));
		commandPanel5.setMaximumSize(new Dimension(380, 20));
		commandPanel5.setSize(280, 20);
		commandPanel.add(commandPanel5);

		commandPanel.add(new JLabel(" "));

		JPanel commandPanel7 = new JPanel();
		commandPanel7.setLayout(new GridLayout(1, 3));
		commandPanel7.setMaximumSize(new Dimension(380, 20));
		commandPanel7.setSize(280, 20);
		commandPanel.add(commandPanel7);

		JPanel commandPanel6 = new JPanel();
		commandPanel6.setLayout(new GridLayout(1, 3));
		commandPanel6.setMaximumSize(new Dimension(380, 20));
		commandPanel6.setSize(280, 20);
		commandPanel.add(commandPanel6);

		commandPanel.add(new JLabel(" "));
		commandPanel.add(new JLabel(" "));

		//
		JPanel commandPanel8 = new JPanel();
		commandPanel8.setLayout(new GridLayout(1, 3));
		commandPanel8.setMaximumSize(new Dimension(380, 20));
		commandPanel8.setSize(280, 20);
		commandPanel8.add(new JLabel("Clear Input Signal"));
		commandPanel.add(commandPanel8);
		JSeparator separator8 = new JSeparator(SwingConstants.HORIZONTAL);
		separator8.setMaximumSize(new Dimension(380, 10));
		commandPanel.add(separator8);

		JPanel commandPanel9 = new JPanel();
		commandPanel9.setLayout(new GridLayout(1, 3));
		commandPanel9.setMaximumSize(new Dimension(380, 20));
		commandPanel9.setSize(280, 20);
		commandPanel.add(commandPanel9);
		
		//Output Sounds (Embed)
		commandPanel11.add(new JLabel("AI mouth (Embed)"));
		
		OUTPUT_SOUND_FIELD = new JTextField();
		OUTPUT_SOUND_FIELD.setMaximumSize(new Dimension(100, 20));
		commandPanel11.add(OUTPUT_SOUND_FIELD);
		
		JPanel outSoundButtonPane = new JPanel();
		outSoundButtonPane.setLayout(new BoxLayout(outSoundButtonPane, BoxLayout.Y_AXIS));
		commandPanel11.add(outSoundButtonPane);

		outSoundButton = new JButton("outputSound");
		outSoundButton.addActionListener(this);
		outSoundButton.setMinimumSize(new Dimension(140, 20));
		outSoundButton.setMaximumSize(new Dimension(140, 20));
		outSoundButtonPane.add(outSoundButton);

		//Output Body (Embed)
		commandPanel2.add(new JLabel("AI body (Embed)"));
		
		OUTPUT_BODY_FIELD = new JTextField("+");
		OUTPUT_BODY_FIELD.setMaximumSize(new Dimension(100, 20));
		commandPanel2.add(OUTPUT_BODY_FIELD);
		
		JPanel outBodyButtonPane = new JPanel();
		outBodyButtonPane.setLayout(new BoxLayout(outBodyButtonPane, BoxLayout.Y_AXIS));
		commandPanel2.add(outBodyButtonPane);

		outBodyButton = new JButton("outputBody");
		outBodyButton.addActionListener(this);
		outBodyButton.setMinimumSize(new Dimension(140, 20));
		outBodyButton.setMaximumSize(new Dimension(140, 20));
		outBodyButtonPane.add(outBodyButton);

		//Output Image
		check0_0 = new JCheckBox("0-0");
		check1_0 = new JCheckBox("1-0");
		check2_0 = new JCheckBox("2-0");
		check3_0 = new JCheckBox("3-0");
		check4_0 = new JCheckBox("4-0");
		check0_1 = new JCheckBox("0-1");
		check1_1 = new JCheckBox("1-1");
		check2_1 = new JCheckBox("2-1");
		check3_1 = new JCheckBox("3-1");
		check4_1 = new JCheckBox("4-1");
		commandPanel4.add(check0_0);
		commandPanel4.add(check1_0);
		commandPanel4.add(check2_0);
		commandPanel4.add(check3_0);
		commandPanel4.add(check4_0);
		commandPanel4.add(check0_1);
		commandPanel4.add(check1_1);
		commandPanel4.add(check2_1);
		commandPanel4.add(check3_1);
		commandPanel4.add(check4_1);

		outImageButton = new JButton("outputImage");
		outImageButton.addActionListener(this);
		commandPanel5.add(outImageButton);

		//Output Sounds (Trigger)
		commandPanel7.add(new JLabel("AI mouth (Trigger)"));
		
		OUTPUT_SOUND_FIELD_T = new JTextField();
		OUTPUT_SOUND_FIELD_T.setMaximumSize(new Dimension(100, 20));
		commandPanel7.add(OUTPUT_SOUND_FIELD_T);
		
		JPanel outSoundButtonPane_t = new JPanel();
		outSoundButtonPane_t.setLayout(new BoxLayout(outSoundButtonPane_t, BoxLayout.Y_AXIS));
		commandPanel7.add(outSoundButtonPane_t);

		outSoundButton_t = new JButton("outputSound_t");
		outSoundButton_t.addActionListener(this);
		outSoundButton_t.setMinimumSize(new Dimension(140, 20));
		outSoundButton_t.setMaximumSize(new Dimension(140, 20));
		outSoundButtonPane_t.add(outSoundButton_t);

		//Output Body (Trigger)
		commandPanel6.add(new JLabel("AI body (Trigger)"));
		
		OUTPUT_BODY_FIELD_T = new JTextField("+");
		OUTPUT_BODY_FIELD_T.setMaximumSize(new Dimension(100, 20));
		commandPanel6.add(OUTPUT_BODY_FIELD_T);
		
		JPanel outBodyButtonPane_t = new JPanel();
		outBodyButtonPane_t.setLayout(new BoxLayout(outBodyButtonPane_t, BoxLayout.Y_AXIS));
		commandPanel6.add(outBodyButtonPane_t);

		outBodyButton_t = new JButton("outputBody_t");
		outBodyButton_t.addActionListener(this);
		outBodyButton_t.setMinimumSize(new Dimension(140, 20));
		outBodyButton_t.setMaximumSize(new Dimension(140, 20));
		outBodyButtonPane_t.add(outBodyButton_t);

		//Clear InputSignal
		clearSignalButton = new JButton("clearSignal");
		clearSignalButton.addActionListener(this);
		commandPanel9.add(clearSignalButton);

		//Clear Pleasure History
		clearPleasureHistoryButton = new JButton("clearPleasureHistory");
		clearPleasureHistoryButton.addActionListener(this);
		commandPanel9.add(clearPleasureHistoryButton);
		
		//Think
		JPanel thinkViewPanel = new JPanel();
		thinkViewPanel.setLayout(new BoxLayout(thinkViewPanel, BoxLayout.Y_AXIS));

		thinkViewPanel.add(new JLabel("[ Something to do ]"));
		MAX_DESIRE_AREA = new JTextArea(22, 2);
		MAX_DESIRE_AREA.setEditable(false);
		JScrollPane scrollPane7 = new JScrollPane(MAX_DESIRE_AREA);
		scrollPane7.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane7.setPreferredSize(new Dimension(300, 100));
		thinkViewPanel.add(scrollPane7);
		
		thinkViewPanel.add(new JLabel(" "));

		thinkViewPanel.add(new JLabel("[ Plan ] <It displays, only when planned.>"));
		VIEW_PLAN_AREA = new JTextArea(22, 28);
		VIEW_PLAN_AREA.setEditable(false);
		JScrollPane scrollPane8 = new JScrollPane(VIEW_PLAN_AREA);
		scrollPane8.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane8.setPreferredSize(new Dimension(300, 620));
		thinkViewPanel.add(scrollPane8);

		tabbedpane.addTab("Think", thinkViewPanel);
		
		//Azԕ\p̃^u
		STATUS_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane2 = new JScrollPane(STATUS_AREA);
		scrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane2.setPreferredSize(new Dimension(300, 760));
		if(bDebug) {
			tabbedpane.addTab("Nerve", scrollPane2);
		}
		
		//Ü
		TEMPT_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane3 = new JScrollPane(TEMPT_AREA);
		scrollPane3.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane3.setPreferredSize(new Dimension(300, 760));
		if(bDebug) {
			tabbedpane.addTab("Tempt", scrollPane3);
		}

		//VOi
		SIGNAL_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane4 = new JScrollPane(SIGNAL_AREA);
		scrollPane4.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane4.setPreferredSize(new Dimension(300, 760));
		if(bDebug) {
			tabbedpane.addTab("Signal", scrollPane4);
		}

		//v
		PLAN_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane5 = new JScrollPane(PLAN_AREA);
		scrollPane5.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane5.setPreferredSize(new Dimension(300, 760));
		if(bDebug) {
			tabbedpane.addTab("Plan", scrollPane5);
		}

		//sʋL^
		PHYSICAL_RECORD_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane6 = new JScrollPane(PHYSICAL_RECORD_AREA);
		scrollPane6.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane6.setPreferredSize(new Dimension(300, 760));
		if(bDebug) {
			tabbedpane.addTab("PWorkingMemory", scrollPane6);
		}

		//AI_hL^
		LOGICAL_RECORD_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane10 = new JScrollPane(LOGICAL_RECORD_AREA);
		scrollPane10.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane10.setPreferredSize(new Dimension(300, 760));
		if(bDebug) {
			tabbedpane.addTab("LWorkingMemory", scrollPane10);
		}

		//yXg
		PLEASURE_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane9 = new JScrollPane(PLEASURE_AREA);
		scrollPane9.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane9.setPreferredSize(new Dimension(300, 760));
		if(bDebug) {
			tabbedpane.addTab("Pleasure", scrollPane9);
		}

		//ݒ^u
		JPanel associationSettingPanel = new JPanel();
		associationSettingPanel.setLayout(new BoxLayout(associationSettingPanel, BoxLayout.Y_AXIS));

		associationSettingPanel.add(new JLabel("[ Nerve view setting ]"));
		
		//
		JSeparator separator0 = new JSeparator(SwingConstants.HORIZONTAL);
		separator0.setMaximumSize(new Dimension(800, 10));
		associationSettingPanel.add(separator0);

		nerveCheck = new JCheckBox("Association Nerve View", false);
		desireCheck  = new JCheckBox("Environment Desire Nerve View", true);
		abstractDesireCheck  = new JCheckBox("Abstract Desire Nerve View", true);
		physicalDesireCheck  = new JCheckBox("Physical Desire Nerve View", false);
		partsCheck = new JCheckBox("Nerve Parts View", false);
		nerveCheck.setActionCommand("nerveCheck");
		desireCheck.setActionCommand("desireCheck");
		abstractDesireCheck.setActionCommand("abstractDesireCheck");
		physicalDesireCheck.setActionCommand("physicalDesireCheck");
		partsCheck.setActionCommand("partsCheck");
		associationSettingPanel.add(nerveCheck);
		associationSettingPanel.add(desireCheck);
		associationSettingPanel.add(abstractDesireCheck);
		associationSettingPanel.add(physicalDesireCheck);
		associationSettingPanel.add(partsCheck);
		nerveCheck.addActionListener(this);
		desireCheck.addActionListener(this);
		abstractDesireCheck.addActionListener(this);
		physicalDesireCheck.addActionListener(this);
		partsCheck.addActionListener(this);

		//
		JSeparator separator1 = new JSeparator(SwingConstants.HORIZONTAL);
		separator1.setMaximumSize(new Dimension(400, 10));
		associationSettingPanel.add(separator1);

		//OUTPUTID
		imageCheck = new JCheckBox("IMAGE view", true);
		charInCheck = new JCheckBox("CHAR_IN view", true);
		charOutCheck = new JCheckBox("CHAR_OUT view", true);
		eyesCheck = new JCheckBox("Eyes view", true);
		imageCheck.setActionCommand("imageCheck");
		charInCheck.setActionCommand("charInCheck");
		charOutCheck.setActionCommand("charOutCheck");
		eyesCheck.setActionCommand("eyesCheck");
		associationSettingPanel.add(imageCheck);
		associationSettingPanel.add(charInCheck);
		associationSettingPanel.add(charOutCheck);
		associationSettingPanel.add(eyesCheck);
		imageCheck.addActionListener(this);
		charInCheck.addActionListener(this);
		charOutCheck.addActionListener(this);
		eyesCheck.addActionListener(this);
		
		DevelopHelper.addDebugOutputID(GroupingOutputId.class);
		DevelopHelper.addDebugOutputID(CharacterInOutputId.class);
		DevelopHelper.addDebugOutputID(ImageOutputId.class);
		DevelopHelper.addDebugOutputID(CharacterOutOutputId.class);
		DevelopHelper.addDebugOutputID(CharacterOutOneId.class);
		DevelopHelper.addDebugOutputID(CharacterOutTwoId.class);
		DevelopHelper.addDebugOutputID(CharacterOutThreeId.class);
		DevelopHelper.addDebugOutputID(CharacterOutFourId.class);
		DevelopHelper.addDebugOutputID(CharacterOutFiveId.class);
		DevelopHelper.addDebugOutputID(CharacterOutSixId.class);
		DevelopHelper.addDebugOutputID(CharacterOutSevenId.class);
		DevelopHelper.addDebugOutputID(CharacterOutEightId.class);
		DevelopHelper.addDebugOutputID(CharacterOutNineId.class);
		DevelopHelper.addDebugOutputID(CharacterOutTenId.class);
		DevelopHelper.addDebugOutputID(BodyWalkId.class);
		DevelopHelper.addDebugOutputID(EyeOutputId.class);
		
		//
		JSeparator separator5 = new JSeparator(SwingConstants.HORIZONTAL);
		separator5.setMaximumSize(new Dimension(400, 10));
		associationSettingPanel.add(separator5);
		
		JCheckBox reverseCheck = new JCheckBox("connection view");
		reverseCheck.addActionListener(this);
		reverseCheck.setActionCommand("reverseCheck");
		associationSettingPanel.add(reverseCheck);

		//
		JSeparator separator2 = new JSeparator(SwingConstants.HORIZONTAL);
		separator2.setMaximumSize(new Dimension(400, 10));
		associationSettingPanel.add(separator2);

		JCheckBox temptCheck = new JCheckBox("tempt level view");
		temptCheck.addActionListener(this);
		temptCheck.setActionCommand("temptCheck");
		associationSettingPanel.add(temptCheck);
		
		//
		JSeparator separator3 = new JSeparator(SwingConstants.HORIZONTAL);
		separator3.setMaximumSize(new Dimension(400, 20));
		associationSettingPanel.add(separator3);

		associationSettingPanel.add(new JLabel("[ Temptation zone / Success plan view setting ]"));
		
		//
		JSeparator separator4 = new JSeparator(SwingConstants.HORIZONTAL);
		separator4.setMaximumSize(new Dimension(800, 10));
		associationSettingPanel.add(separator4);

		//Level Change
		associationSettingPanel.add(new JLabel("The desire specified below is displayed.(Tempt Tab)"));
		associationSettingPanel.add(new JLabel("Experience of the past of the desire specified below is displayed.(Plan Tab)"));
		associationSettingPanel.add(new JLabel("When specified ID is not found, the maximum desire instance is displayed."));
		TEMPT_NERVE_ID_FIELD = new JTextField("Please set up here ID of the desire nerve displayed on (Tempt/Plan)View.", 5);
		TEMPT_NERVE_ID_FIELD.setMaximumSize(new Dimension(800, 20));
		associationSettingPanel.add(TEMPT_NERVE_ID_FIELD);

		associationSettingPanel.add(new JLabel("The Temptation level of ID specified above can be changed into below."));
		
		TEMPT_LEVEL_CHANGE_FIELD = new JTextField();
		TEMPT_LEVEL_CHANGE_FIELD.setMaximumSize(new Dimension(100, 20));
		associationSettingPanel.add(TEMPT_LEVEL_CHANGE_FIELD);
		temptChangeButton = new JButton("change");
		temptChangeButton.setActionCommand("changeTempt");
		temptChangeButton.setMaximumSize(new Dimension(100, 20));
		temptChangeButton.addActionListener(this);
		associationSettingPanel.add(temptChangeButton);

		//commonPlan remove
		associationSettingPanel.add(new JLabel("A part of commonPlan of ID specified above can be deleted (Index is specified)."));
		COMMON_PLAN_REMOVE_FIELD = new JTextField();
		COMMON_PLAN_REMOVE_FIELD.setMaximumSize(new Dimension(100, 20));
		associationSettingPanel.add(COMMON_PLAN_REMOVE_FIELD);
		commonPlanRemoveButton = new JButton("remove");
		commonPlanRemoveButton.setActionCommand("removeCommonPlan");
		commonPlanRemoveButton.setMaximumSize(new Dimension(100, 20));
		commonPlanRemoveButton.addActionListener(this);
		associationSettingPanel.add(commonPlanRemoveButton);

		//Pleasure remove
		associationSettingPanel.add(new JLabel("Pleasure of ID specified above can be deleted (Index is specified)."));
		PLEASURE_REMOVE_FIELD = new JTextField();
		PLEASURE_REMOVE_FIELD.setMaximumSize(new Dimension(100, 20));
		associationSettingPanel.add(PLEASURE_REMOVE_FIELD);
		pleasureRemoveButton = new JButton("remove");
		pleasureRemoveButton.setActionCommand("removePleasure");
		pleasureRemoveButton.setMaximumSize(new Dimension(100, 20));
		pleasureRemoveButton.addActionListener(this);
		associationSettingPanel.add(pleasureRemoveButton);

		//desireNerve remove
		associationSettingPanel.add(new JLabel("Desire Nerve of ID specified above can be deleted (Index is specified)."));
		DESIRE_NERVE_REMOVE_FIELD = new JTextField();
		DESIRE_NERVE_REMOVE_FIELD.setMaximumSize(new Dimension(100, 20));
		associationSettingPanel.add(DESIRE_NERVE_REMOVE_FIELD);
		desireNerveRemoveButton = new JButton("remove");
		desireNerveRemoveButton.setActionCommand("removeDesireNerve");
		desireNerveRemoveButton.setMaximumSize(new Dimension(100, 20));
		desireNerveRemoveButton.addActionListener(this);
		associationSettingPanel.add(desireNerveRemoveButton);
		
		//desireNerve execute
		associationSettingPanel.add(new JLabel("Desire Nerve of ID specified above can be execute (Index is specified)."));
		DESIRE_NERVE_EXEC_FIELD = new JTextField();
		DESIRE_NERVE_EXEC_FIELD.setMaximumSize(new Dimension(100, 20));
		associationSettingPanel.add(DESIRE_NERVE_EXEC_FIELD);
		desireNerveExecButton = new JButton("exec");
		desireNerveExecButton.setActionCommand("execDesireNerve");
		desireNerveExecButton.setMaximumSize(new Dimension(100, 20));
		desireNerveExecButton.addActionListener(this);
		associationSettingPanel.add(desireNerveExecButton);

		if(bDebug) {
			tabbedpane.addTab("settings", associationSettingPanel);
		}

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("AI Status Watcher");
		setSize(500, 760);
		setVisible(true);
		//setAlwaysOnTop(true);
		
	}
	
	public static void setMaxDesireText(String str) {
		MAX_DESIRE_AREA.setText(str);
	}
	
	public static void setViewPlanText(String str) {
		VIEW_PLAN_AREA.setText(str);
	}
	
	public static void setStatusText(String statusStr) {
		STATUS_AREA.setText(statusStr);
	}

	public static void setSignalText(String signalStr) {
		SIGNAL_AREA.setText(signalStr);
	}

	public static void setPlanText(String planStr) {
		PLAN_AREA.setText(planStr);
	}

	public static void setPhysicalWorkingText(String recordStr) {
		PHYSICAL_RECORD_AREA.setText(recordStr);
	}

	public static void setLogicalWorkingText(String recordStr) {
		LOGICAL_RECORD_AREA.setText(recordStr);
	}

	public static void setPleasureText(String pleasureStr) {
		PLEASURE_AREA.setText(pleasureStr);
	}

	public static void setTemptText(String temptStr) {
		TEMPT_AREA.setText(temptStr);
	}

	public static long getTemptNerveID() {
		String s = TEMPT_NERVE_ID_FIELD.getText();
		try {
			return Long.parseLong(s);
		}
		catch(NumberFormatException e) {
			return 0;
		}
	}
	
	public static void setAssociationStatusCount(int value, int max) {
		SIGNAL_METER.setValue(value, max);
		SIGNAL_METER.repaint();
	}
	
	public static void setEnergyMeter(int value, int max) {
		ENERGY_METER.setValue(value, max);
		ENERGY_METER.repaint();
	}

	public void actionPerformed(ActionEvent e){
		//System.out.println(e.getActionCommand());
		
		String command = e.getActionCommand();
		
		if("nerveCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvNerve(box.isSelected());
		}
		else if("desireCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvDesireNerve(box.isSelected());
		}
		else if("physicalDesireCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvPhysicalNerve(box.isSelected());
		}
		else if("partsCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvPartsNerve(box.isSelected());
		}
		else if("reverseCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			DevelopHelper.setDebugReverseNerveView(checkBox.isSelected());
		}
		else if("temptCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			DevelopHelper.setDebugTemptView(checkBox.isSelected());
		}
		else if("educationCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			try {
				DesireEmbeder.setEducationMode(checkBox.isSelected());
				outSoundButton.setEnabled(checkBox.isSelected());
				outBodyButton.setEnabled(checkBox.isSelected());
				OUTPUT_SOUND_FIELD.setEditable(checkBox.isSelected());
				OUTPUT_BODY_FIELD.setEditable(checkBox.isSelected());
			}
			catch(RunningEducationModeException reme) {
				JFrame frame = new JFrame("Warning");
				frame.addWindowListener(new WindowAdapter() {
					public void windowClosing(WindowEvent e) { 
						System.exit(0); 
					}
				});
				frame.setSize(new Dimension(300,200));
				frame.setVisible(true);
				JOptionPane.showMessageDialog(frame, "瓮쒆ׁ̈A烂[hύXł܂BԂoĂĎsĂB");

			}
		}
		else if("preinstallCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			PhysicalDesirePreInstaller.setPreInstallationMode(checkBox.isSelected());
		}
		else if("outputSound".equals(command)) {
			String text = OUTPUT_SOUND_FIELD.getText();
			if (text == null || text.length() == 0) {
				return;
			}

			if("=".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.EQUALS_DESIRE);
			}
			else if("1".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.ONE_SOUND_DESIRE);
			}
			else if("2".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.TWO_SOUND_DESIRE);
			}
			else if("3".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.THREE_SOUND_DESIRE);
			}
			else if("4".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.FOUR_SOUND_DESIRE);
			}
			else if("5".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.FIVE_SOUND_DESIRE);
			}
			else if("6".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.SIX_SOUND_DESIRE);
			}
			else if("7".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.SEVEN_SOUND_DESIRE);
			}
			else if("8".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.EIGHT_SOUND_DESIRE);
			}
			else if("9".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.NINE_SOUND_DESIRE);
			}
			else if("10".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.TEN_SOUND_DESIRE);
			}
		}
		else if("outputBody".equals(command)) {
			String text = OUTPUT_BODY_FIELD.getText();

			if("walk".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.WALK_DESIRE);
			}
			else if("+".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.ADD_DESIRE);
			}
			else if("-".equals(text)) {
				DesireEmbeder.add(PhysicalDesireConst.REMOVE_DESIRE);
			}
		}
		else if("outputImage".equals(command)) {
			List<Point> pointList = new ArrayList<Point>();
			if(check0_0.isSelected()) {
				pointList.add(new Point(0, 0));
			}
			if(check1_0.isSelected()) {
				pointList.add(new Point(1, 0));
			}
			if(check2_0.isSelected()) {
				pointList.add(new Point(2, 0));
			}
			if(check3_0.isSelected()) {
				pointList.add(new Point(3, 0));
			}
			if(check4_0.isSelected()) {
				pointList.add(new Point(4, 0));
			}
			if(check0_1.isSelected()) {
				pointList.add(new Point(0, 1));
			}
			if(check1_1.isSelected()) {
				pointList.add(new Point(1, 1));
			}
			if(check2_1.isSelected()) {
				pointList.add(new Point(2, 1));
			}
			if(check3_1.isSelected()) {
				pointList.add(new Point(3, 1));
			}
			if(check4_1.isSelected()) {
				pointList.add(new Point(4, 1));
			}
			
			if(pointList.size() > 0) {
				try {
					ImageOutputId imageOutputId = new ImageOutputId();
					imageOutputId.setInnerOption(
							new ImageSignalData(
									Color.orange,
									PolygonAbstractSample.getInstance(),
									pointList));
					OutputTriggerIF trigger = imageOutputId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIImageo͂܂B" + pointList);
				}
				catch(Exception ex) {
					ex.printStackTrace();
				}
			}
		}
		else if("clearSignal".equals(command)) {
			DevelopHelper.clearInputSignal();
			//EyeIF̏ɖ߂
			ImageSubstance.getInstance().changeModeNormal();
			System.out.println("\r\n͎hEEyeIF̏ԂNA܂B\r\n");
		}
		else if("clearPleasureHistory".equals(command)) {
			DevelopHelper.clearPleasureHistory();
			System.out.println("\r\ny̐isNA܂B\r\n");
		}
		else if("outputBody_t".equals(command)) {
			String text = OUTPUT_BODY_FIELD.getText();

			if("walk".equals(text)) {
				//
				throw new UnsupportedOperationException();
			}
			else if("+".equals(text)) {
				try {
					EyeOutputId eyeOutputId = new EyeOutputId();
					OutputTriggerIF trigger = eyeOutputId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIEyeo͂܂B");
				}
				catch(Exception ex) {
					ex.printStackTrace();
				}
			}
			else if("-".equals(text)) {
				//
				throw new UnsupportedOperationException();
			}
		}
		else if("outputSound_t".equals(command)) {
			String text = OUTPUT_SOUND_FIELD_T.getText();
			if (text == null || text.length() == 0) {
				return;
			}

			try {
				if("=".equals(text)) {
					CharacterOutEqualsId characterOutEqualsId = new CharacterOutEqualsId();
					OutputTriggerIF trigger = characterOutEqualsId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[=]o͂܂B");
				}
				else if("1".equals(text)) {
					CharacterOutOneId characterOutOneId = new CharacterOutOneId();
					OutputTriggerIF trigger = characterOutOneId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[1]o͂܂B");
				}
				else if("2".equals(text)) {
					CharacterOutTwoId characterOutTwoId = new CharacterOutTwoId();
					OutputTriggerIF trigger = characterOutTwoId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[2]o͂܂B");
				}
				else if("3".equals(text)) {
					CharacterOutThreeId characterOutThreeId = new CharacterOutThreeId();
					OutputTriggerIF trigger = characterOutThreeId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[3]o͂܂B");
				}
				else if("4".equals(text)) {
					CharacterOutFourId characterOutFourId = new CharacterOutFourId();
					OutputTriggerIF trigger = characterOutFourId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[4]o͂܂B");
				}
				else if("5".equals(text)) {
					CharacterOutFiveId characterOutFiveId = new CharacterOutFiveId();
					OutputTriggerIF trigger = characterOutFiveId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[5]o͂܂B");
				}
				else if("6".equals(text)) {
					CharacterOutSixId characterOutSixId = new CharacterOutSixId();
					OutputTriggerIF trigger = characterOutSixId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[6]o͂܂B");
				}
				else if("7".equals(text)) {
					CharacterOutSevenId characterOutSevenId = new CharacterOutSevenId();
					OutputTriggerIF trigger = characterOutSevenId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[7]o͂܂B");
				}
				else if("8".equals(text)) {
					CharacterOutEightId characterOutEightId = new CharacterOutEightId();
					OutputTriggerIF trigger = characterOutEightId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[8]o͂܂B");
				}
				else if("9".equals(text)) {
					CharacterOutNineId characterOutNineId = new CharacterOutNineId();
					OutputTriggerIF trigger = characterOutNineId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[9]o͂܂B");
				}
				else if("10".equals(text)) {
					CharacterOutTenId characterOutTenId = new CharacterOutTenId();
					OutputTriggerIF trigger = characterOutTenId.newTriggerInstance();
					trigger.setElectricPotential(1);
					trigger.start();
					System.out.println("AIMouth[10]o͂܂B");
				}
			}
			catch(Exception ex) {
				ex.printStackTrace();
			}
		}
		else if("imageCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(ImageOutputId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(ImageOutputId.class);
			}
		}
		else if("charInCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(CharacterInOutputId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(CharacterInOutputId.class);
			}
		}
		else if("charOutCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(CharacterOutOutputId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(CharacterOutOutputId.class);
			}
		}
		else if("eyesCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(EyeOutputId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(EyeOutputId.class);
			}
		}
		else if("changeTempt".equals(command)) {
			String id = TEMPT_NERVE_ID_FIELD.getText();
			NerveIF nerve = null;
			
			try{
				long key = Long.valueOf(id);
				nerve = DevelopHelper.searchNerve(key);

				if(nerve == null || (nerve instanceof DesireNerveIF) == false) {
					nerve = (NerveIF)DevelopHelper.getMaxPleasure().getCopyStrongNoAbstractDesireList().get(0);
				}
			}
			catch(Exception ex) {
				//őlɐݒ肷
				nerve = (NerveIF)DevelopHelper.getMaxPleasure().getCopyStrongNoAbstractDesireList().get(0);
			}
			
			if(nerve == null) {
				return;
			}
			
			int iLevel = 0;
			try {
				iLevel = Integer.valueOf(TEMPT_LEVEL_CHANGE_FIELD.getText());
			}
			catch(Exception ex) {
				TEMPT_LEVEL_CHANGE_FIELD.setText("set up a numerical value.");
				return;
			}
			
			DesireNerveIF desireNerve = (DesireNerveIF)nerve;
			desireNerve.setDesireMaxElectricPotential(iLevel);
			desireNerve.setDesireElectricPotential(iLevel);
			
		}
		else if("removeCommonPlan".equals(command)) {
			String id = TEMPT_NERVE_ID_FIELD.getText();
			NerveIF nerve = null;
			
			try{
				long key = Long.valueOf(id);
				nerve = DevelopHelper.searchNerve(key);

				if(nerve == null || (nerve instanceof DesireNerveIF) == false) {
					nerve = (NerveIF)DevelopHelper.getMaxPleasure().getCopyStrongNoAbstractDesireList().get(0);
				}
			}
			catch(Exception ex) {
				//őlɐݒ肷
				nerve = (NerveIF)DevelopHelper.getMaxPleasure().getCopyStrongNoAbstractDesireList().get(0);
			}
			
			if(nerve == null) {
				return;
			}
			
			int iIndex = 0;
			try {
				iIndex = Integer.valueOf(COMMON_PLAN_REMOVE_FIELD.getText());
			}
			catch(Exception ex) {
				COMMON_PLAN_REMOVE_FIELD.setText("set up a numerical value.");
				return;
			}
			
			DesireNerveIF desireNerve = (DesireNerveIF)nerve;
			List<List<DesireNerveIF>> targetDesireNerve = desireNerve.getSuccessCommonDesireList();
			targetDesireNerve.remove(iIndex);
			
		}
		else if("removePleasure".equals(command)) {
			String id = PLEASURE_REMOVE_FIELD.getText();
			
			try{
				long key = Long.valueOf(id);
				DevelopHelper.removePleasure(key);

			}
			catch(Exception ex) {
				PLEASURE_REMOVE_FIELD.setText("set up a numerical value.");
				return;
			}
			
		}
		else if("removeDesireNerve".equals(command)) {
			String id = DESIRE_NERVE_REMOVE_FIELD.getText();
			
			try{
				long key = Long.valueOf(id);
				DevelopHelper.invalidationNerve(key);

			}
			catch(Exception ex) {
				DESIRE_NERVE_REMOVE_FIELD.setText("set up a numerical value.");
				return;
			}
			
		}
		else if("execDesireNerve".equals(command)) {
			String id = DESIRE_NERVE_EXEC_FIELD.getText();
			
			try{
				long key = Long.valueOf(id);
				DevelopHelper.execDesireNerve(key);
			}
			catch(Exception ex) {
				DESIRE_NERVE_EXEC_FIELD.setText("set up a numerical value.");
				return;
			}
			
		}
		else if("savememory".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Memory is saved. Is it all right? \n(It takes about " +
					AICoreConst.MAX_EXEC_CONTDITION_TIME / 1000 + " seconds.)");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.outputMemory()) {
					JOptionPane.showMessageDialog(this, "It succeeded in preservation of memory.");
				}
				else {
					JOptionPane.showMessageDialog(this, "It failed in preservation of memory.");
				}
			}
		}
		else if("loadmemory".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Memory is restored. Is it all right? \n(It takes about " +
					AICoreConst.MAX_EXEC_CONTDITION_TIME / 1000 + " seconds.)");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.inputMemory()) {
					JOptionPane.showMessageDialog(this, "It succeeded in restoration of memory.");
				}
				else {
					JOptionPane.showMessageDialog(this, "It failed in restoration of memory.");
				}
			}
		}
		else if("recodesignal".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Record of signal data is started for high-speed education.\nIs it all right?");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.startEducationOutput()) {
					JOptionPane.showMessageDialog(this, "Record was started.");
				}
				else {
					JOptionPane.showMessageDialog(this, "Record was not started.");
				}
			}
		}
		else if("stoprecode".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Record of signal data is stoped for high-speed education.\nIs it all right?");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.stopEducationOutput()) {
					JOptionPane.showMessageDialog(this, "Record was stoped.");
				}
				else {
					JOptionPane.showMessageDialog(this, "Record was not stoped.");
				}
			}
		}
		else if("starteducation".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Education is started based on the recorded data. Is it all right?\n(It takes about " +
				MemoryControler.getSignalDataCount() * LightGenerator.LIGHT_INTERVAL / 1000 + " seconds.)");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.inputEducation()) {
					JOptionPane.showMessageDialog(this, "High-speed education was completed.");
				}
				else {
					JOptionPane.showMessageDialog(this, "High-speed education was failed.");
				}
			}
		}
		
	}

}
