package jp.co.celestee.ai.interfaces.status;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;

@SuppressWarnings("serial")
public class JStatusMeter extends JComponent{

	private Image  offScreenImg;					// ItXN[
	private Graphics grf;
   	
	private int width = 400;
	private int height = 12;
	
	private Color _color = null;
	private Color _bgColor = null;
	private Color _charColor = null;
	private int _value = 0;
	private int _maxValue = 0;

	public JStatusMeter() {
		init();
	}
	
	public void init(){
		// ItXN[̐ݒ
		offScreenImg = getImage();
		grf = offScreenImg.getGraphics();

	}
	
	public void setColor(Color color, Color bgColor, Color charColor) {
		_color = color;
		_bgColor = bgColor;
		_charColor = charColor;
	}
	
	public void setValue(int value, int maxValue) {
		_value = value;
		_maxValue = maxValue;
	}

	public void paint(Graphics g) {
		update(g);
	}

	public void update(Graphics g){

		//`
		grf.setColor(_bgColor);
		grf.fillRect(0, 0, width, height);
		
		grf.setColor(_color);
		int iWidth = _maxValue == 0 || _value == 0 ? 0 : _value * width / _maxValue;
		grf.fillRect(0, 0, iWidth, height);
		grf.setColor(_charColor);
		grf.drawString(_value + " / " + _maxValue, 100, 11);
		
		
		// ItXN[̃C[WꋓɎۂ̕\̈ɕ`
		g.drawImage(offScreenImg, 0, 0, this);	

	}

	BufferedImage getImage() {
		
		BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
		Graphics g = bi.createGraphics();
		paintComponent(g);
		return bi;
	}
	
	void setImage(Image img) {
		offScreenImg = img;
		repaint();
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		if(offScreenImg != null){
			int w = offScreenImg.getWidth(this);
			int h = offScreenImg.getHeight(this);
			if(w != width || h != height){
				width = w;
				height = h;
				this.setPreferredSize(new Dimension(width, height));
			}
			g.drawImage(offScreenImg, 0, 0, this);
		}
	}
}
