package jp.co.celestee.external.object;

import java.awt.Point;
import java.util.List;

import jp.co.celestee.external.rule.RuleIF;
import jp.co.celestee.external.rule.RuleManager;
import jp.co.celestee.external.rule.light.LightRuleAccessorIF;
import jp.co.celestee.external.rule.light.LightRuleData;
import jp.co.celestee.external.rule.sound.SoundRule;
import jp.co.celestee.external.rule.sound.SoundRuleAccessorIF;
import jp.co.celestee.external.rule.sound.SoundRuleData;

public class Answer extends Thread implements SoundRuleAccessorIF, LightRuleAccessorIF{
	
	private static Answer subInstance = new Answer();
	
	/** ʏ̌ */
	private int polygonCount = 0;
	
	/** l */
	private int soundNo = 0;
	
	private boolean bSwitch = false;
	
	private Answer() {}
	
	public static Answer getInstance() {
		return subInstance;
	}
	
	private synchronized void execute() {

		if(bSwitch == false) {
			return;
		}
		
		//ʂƓ̐lŃLb`(܂́A̋t)GREATɏo
		if(polygonCount > 0 && polygonCount == soundNo) {
			//[֓
			SoundRuleData ruleData = new SoundRuleData();
			ruleData.setContents("GREAT!");
			ruleData.setPotential(10);
			ruleData.setType(50);
			
			try {
				Thread.sleep(500);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}

			RuleIF rule = RuleManager.getInstance().getRule(SoundRule.SOUND_RULE);
			rule.input(ruleData);
			
			polygonCount = 0;
			soundNo = 0;
		}

	}

	@Override
	public void inputLight(LightRuleData ruleData) {
		List<Point> pointList = ruleData.getPointList();
		polygonCount = pointList == null ? 0 : pointList.size();
		
		execute();
	}

	@Override
	public void inputSound(SoundRuleData ruleData) {
		String contents = ruleData.getContents();
		try {
			soundNo = Integer.parseInt(contents);
		}
		catch(Exception e) {
			soundNo = 0;
		}
		
		execute();
	}
	
	/**
	 * ON,OFFXCb`̐؂ւ
	 * @param bOnOff
	 */
	public void setSwitch(boolean bOnOff) {
		bSwitch = bOnOff;
	}
	
}
