package jp.co.celestee.external.object;

import javax.swing.JTextArea;

import jp.co.celestee.external.rule.RuleIF;
import jp.co.celestee.external.rule.RuleManager;
import jp.co.celestee.external.rule.sound.SoundRule;
import jp.co.celestee.external.rule.sound.SoundRuleData;

public class Loudspeaker extends Thread {
	
	private static Loudspeaker subInstance = new Loudspeaker();
	
	private Loudspeaker() {}
	
	public static Loudspeaker getInstance() {
		return subInstance;
	}

	private static JTextArea _textArea = null;

	public void setMonitor(JTextArea jArea) {
		_textArea = jArea;
	}
	
	public void run() {

		RuleIF rule = RuleManager.getInstance().getRule(SoundRule.SOUND_RULE);

		try {
			while(true) {
				
				Thread.sleep(500);
				
				String sText = _textArea.getText();
				if(sText == null || sText.indexOf("\n") == -1) {
					continue;
				}

				sText = sText.replaceAll("\n", "");
				
				//[֓
				for(int i = 0; i < sText.length(); i++) {
					SoundRuleData ruleData = new SoundRuleData();
					ruleData.setContents(sText.substring(i, i+1));
					ruleData.setPotential(5);
					ruleData.setType(1);
					rule.input(ruleData);
					
					Thread.sleep(100);
				}

				_textArea.setText("");

			}
		}
		catch(Throwable t) {
			System.out.println("zÕG[܂B");
			_textArea.setText("zÕG[܂B");
			t.printStackTrace();
		}

	}
	
}
