package jp.co.celestee.external.object;

import jp.co.celestee.external.rule.sound.SoundRuleAccessorIF;
import jp.co.celestee.external.rule.sound.SoundRuleData;
import jp.co.celestee.external.virtual.JRuleFrame;

public class ViewConnector extends Thread implements SoundRuleAccessorIF {
	
	private static ViewConnector _subInstance = new ViewConnector();
	
	private boolean _bSwitch = true;
	
	private JRuleFrame _frame = null;
	
	private ViewConnector() {}
	
	public static ViewConnector getInstance() {
		return _subInstance;
	}
	
	public void setSoundViewer(JRuleFrame frame) {
		_frame = frame;
	}
	
	@Override
	public void inputSound(SoundRuleData ruleData) {
		if(_bSwitch == false) {
			return;
		}
		
		//Type=1̂
		//if(ruleData.getType() != 1) return;
		
		String contents = ruleData.getContents();
		
		int soundNo = 0;
		try {
			soundNo = Integer.parseInt(contents);
		}
		catch(Exception e) {
			return;
		}

		_frame.pushOrangeButton(soundNo);
	}
	
	/**
	 * ON,OFFXCb`̐؂ւ
	 * @param bOnOff
	 */
	public void setSwitch(boolean bOnOff) {
		_bSwitch = bOnOff;
	}
	
}
