package jp.co.celestee.external.rule;

import java.util.HashMap;
import java.util.Map;

import jp.co.celestee.external.rule.dinamic.DynamicRule;
import jp.co.celestee.external.rule.light.LightRule;
import jp.co.celestee.external.rule.sound.SoundRule;

public class RuleManager {
	
	private Map<Integer, RuleIF> _map = new HashMap<Integer, RuleIF>();
	
	private static RuleManager _ruleManager = new RuleManager();

	static {
		new SoundRule();
		new LightRule();
		new DynamicRule();
	}
	
	private RuleManager() {
		
	}
	
	public static RuleManager getInstance() {
		return _ruleManager;
	}
	
	public RuleIF getRule(int ruleNo) {
		return (RuleIF)_map.get(ruleNo);
	}
	
	public void setRule(int key, RuleIF rule) {
		_map.put(key, rule);
	}
}
