package jp.co.celestee.external.virtual;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JComponent;

@SuppressWarnings("serial")
public class JAvatarMap extends JComponent {

	private static JAvatarMap jAvatarMap = new JAvatarMap();
	
	private int mapSizeX = 5;	// }Ẍ
	private int mapSizeY = 2;	// }Ẍ
	private int squareWide = 32;					// }Xڂ̕
	private int margin = 20;						// [܂ōsȂ悤]T

	private Image  offScreenImg;					// ItXN[
	private Graphics grf;
   	
	private int width = mapSizeX * squareWide * 2;
	private int height = mapSizeY * squareWide * 2;
	
	private boolean orange[][] = new boolean[mapSizeX][mapSizeY];
	
	private int[] xpoints = new int[]{ 7, 13, 16, 21, 14, 14, 17, 17, 13, 13};
	private int[] ypoints = new int[]{14, 21, 21, 14,  6,  4,  4,  3,  1,  6};
	private Polygon polygon = new Polygon(xpoints, ypoints, ypoints.length);
	private Color orangecolor = Color.orange;

	private JAvatarMap() {
		init();
	}
	
	public static JAvatarMap getInstance() {
		return jAvatarMap;
	}
	
	public void init(){
		// ItXN[̐ݒ
		//offs=createImage(n*square*2,n*square*2);
		offScreenImg = getImage();
		grf = offScreenImg.getGraphics();

	}

	public void paint(Graphics g) {
		update(g);
	}

	public void update(Graphics g){

		grf.translate(0, 0);
		grf.setColor(new Color(170, 170, 170));
		grf.fillRect(0, 0, mapSizeX * squareWide * 2, mapSizeY * squareWide * 2);

		//grf.setColor(Color.black);
		//grf.fillRect(margin,n*square+margin,n*square,20);

		//MAP̕`
		grf.setColor(Color.white);
		grf.fillRect(margin, margin, mapSizeX * squareWide, mapSizeY * squareWide);
		grf.setColor(Color.white);
		for(int i = 0; i < mapSizeX + 2; i++){
			grf.drawLine(i * squareWide + margin, margin, i * squareWide + margin, (mapSizeY + 1) * squareWide + margin);
		}
		for(int i = 0; i < mapSizeY + 2; i++){
			grf.drawLine(margin, i * squareWide + margin, (mapSizeX + 1) * squareWide + margin, i * squareWide + margin);
		}
		
		//Ղ̕`
		int xx,yy;		//}X̍W 
		xx = mapSizeX * squareWide + margin;
		for(int i = 1; i < mapSizeY + 1; i++) {
			yy = i * squareWide + margin;
			grf.drawString(String.valueOf(i - 1), xx + 12, yy - 12);
		}
		yy = (mapSizeY + 1) * squareWide + margin;
		for(int i = 0; i < mapSizeX; i++) {
			xx = i * squareWide + margin;
			grf.drawString(String.valueOf(i), xx + 12, yy - 12);
		}
		
		// ̕`
		for(int y=0; y < mapSizeY; y++){
			yy = y * squareWide + margin;
			for(int x = 0; x < mapSizeX; x++){
				xx = x * squareWide + margin;

				grf.setColor(Color.black);
				grf.fillRect(xx + 1, yy + 1, 31, 31);
				//grf.drawOval(xx + innerMargin, yy + innerMargin, rad, rad);
			}
		}
		
		//~J̕`
		for(int y=0; y < mapSizeY; y++){
			yy = y * squareWide + margin;
			for(int x = 0; x < mapSizeX; x++){
				xx = x * squareWide + margin;

				if(orange[x][y]) {
					grf.translate(xx + 3, yy + 3);
					grf.setColor(orangecolor);
					grf.fillPolygon(polygon);
					grf.translate(-(xx + 3), -(yy + 3));
				}
			}
		}
		
		// ItXN[̃C[WꋓɎۂ̕\̈ɕ`
		g.drawImage(offScreenImg, 0, 0, this);	

	}

	BufferedImage getImage() {
		
		BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
		Graphics g = bi.createGraphics();
		paintComponent(g);
		return bi;
	}
	
	void setImage(Image img) {
		offScreenImg = img;
		repaint();
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		if(offScreenImg != null){
			int w = offScreenImg.getWidth(this);
			int h = offScreenImg.getHeight(this);
			if(w != width || h != height){
				width = w;
				height = h;
				this.setPreferredSize(new Dimension(width, height));
			}
			g.drawImage(offScreenImg, 0, 0, this);
		}
	}

	public void setOrange(int x, int y, boolean on) {
		orange[x][y] = on;
	}

	public List<Point> getOrangeList() {
		List<Point> list = null;
		for(int x=0; x < orange.length; x++) {
			for(int y=0; y < orange[0].length; y++) {
				if(orange[x][y]) {
					if(list == null) {
						list = new ArrayList<Point>();
					}
					list.add(new Point(x, y));
				}
			}
		}
		
		return list;
	}
	
	public Color getOrangeColor() {
		return orangecolor;
	}

	public void setOrangeColor(Color color) {
		orangecolor = color;
	}

	public Polygon getOrangePolygon() {
		return polygon;
	}
	
	public int[] getOrangeXpoints() {
		return xpoints;
	}

	public int[] getOrangeYpoints() {
		return ypoints;
	}
}
