package jp.co.celestee.external.virtual;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JToggleButton;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.Element;

import jp.co.celestee.external.object.Answer;
import jp.co.celestee.external.object.DownPleasureOutputer;
import jp.co.celestee.external.object.GreatSoundOutputer;
import jp.co.celestee.external.object.LightGenerator;
import jp.co.celestee.external.object.MistakeSoundOutputer;
import jp.co.celestee.external.object.UpPleasureOutputer;
import jp.co.celestee.external.object.ViewConnector;
import jp.co.celestee.external.rule.light.LightRuleAccessorIF;
import jp.co.celestee.external.rule.light.LightRuleData;
import jp.co.celestee.external.rule.sound.SoundRuleAccessorIF;
import jp.co.celestee.external.rule.sound.SoundRuleData;

@SuppressWarnings("serial")
public class JRuleFrame extends JFrame  implements SoundRuleAccessorIF, LightRuleAccessorIF, ActionListener {

	private static JRuleFrame _substatnce = new JRuleFrame();
	
	private static long _line = 0;
	
	/** g̓GA */
	private JTextArea LOUDSPEAKER_AREA = null;
	
	/** [ɏo͂ꂽLڂ܂B */
	private JTextArea SOUND_RULE_AREA = null;

	/** Ao^[`悷̈ */
	private JAvatarMap AVATAR_MAP = null;
	
	/** ̐lƉʂ̃~J̐vɔ@B */
	private Answer ANSWER = Answer.getInstance();

	/** F@B */
	private ViewConnector VIEW_CONNECTER = ViewConnector.getInstance();

	private JToggleButton lightOnOffButton = null;
	private JToggleButton orange00Button = null;
	private JToggleButton orange10Button = null;
	private JToggleButton orange20Button = null;
	private JToggleButton orange30Button = null;
	private JToggleButton orange40Button = null;
	private JToggleButton orange01Button = null;
	private JToggleButton orange11Button = null;
	private JToggleButton orange21Button = null;
	private JToggleButton orange31Button = null;
	private JToggleButton orange41Button = null;
	private JToggleButton answerButton = null;
	private JToggleButton viewConnectButton = null;
	
	private List<JToggleButton> viewConnectorList = new ArrayList<JToggleButton>(10);
	
	//y@
	private JButton greatButton = null;
	
	//s@
	private JButton mistakeButton = null;

	//y^sׁiȂłȂłȂǁj
	private JButton upPleasureButton = null;

	//s^sׁiȂǁj
	private JButton downPleasureButton = null;

	private JRuleFrame() {
		JPanel basePane = new JPanel();
		getContentPane().add(basePane);
		
		basePane.setLayout(new BoxLayout(basePane, BoxLayout.X_AXIS));
		basePane.setSize(520, 760);
		
		//PANEL
		JPanel mapPane = new JPanel();
		mapPane.setLayout(new BoxLayout(mapPane, BoxLayout.Y_AXIS));
		mapPane.setSize(400, 760);
		basePane.add(mapPane);
		
		//㕔(MAP)
		mapPane.add(new JLabel("view on rule"));
		AVATAR_MAP = JAvatarMap.getInstance();
		AVATAR_MAP.setBorder(BorderFactory.createLoweredBevelBorder());
		AVATAR_MAP.setPreferredSize(new Dimension(0, 120));
		AVATAR_MAP.setMinimumSize(new Dimension(0, 120));
		mapPane.add(AVATAR_MAP);
		
		URL url = getClass().getClassLoader().getResource("jp/co/celestee/external/virtual/john.png");
		ImageIcon icon = new ImageIcon(url);
		JLabel image = new JLabel(icon);
		mapPane.add(image);

		//(all soundj
		mapPane.add(new JLabel("Sound which sounds in the Rule "));
		SOUND_RULE_AREA = new JTextArea(20, 6);
		SOUND_RULE_AREA.setEditable(false);
		JScrollPane scrollPane2 = new JScrollPane(SOUND_RULE_AREA);
		scrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane2.setPreferredSize(new Dimension(360, 240));
		mapPane.add(scrollPane2);
		
		SOUND_RULE_AREA.getDocument().addDocumentListener(new DocumentListener() {
			@Override
			public void insertUpdate(DocumentEvent e) {
				final Document doc = SOUND_RULE_AREA.getDocument();
				final Element rootElement = doc.getDefaultRootElement();
				if(rootElement.getElementCount() <= 11) {
					return;
				}
				EventQueue.invokeLater(new Runnable() {
					@Override
					public void run() {
						removeLines(doc, rootElement);
					}
				});
				SOUND_RULE_AREA.setCaretPosition(doc.getLength());
			}
			
			private void removeLines(Document doc, Element rootElement) {
				Element fl = rootElement.getElement(0);
				try{
					doc.remove(0, fl.getEndOffset());
				}
				catch(BadLocationException e) {
					System.out.println(e);
				}
			}
			
			@Override
			public void removeUpdate(DocumentEvent e) {}
			
			@Override
			public void changedUpdate(DocumentEvent e) {}
		});

		//(Loudspeaker)
		mapPane.add(new JLabel("LoudSpeaker (it can kick in the talk to the Rule)"));
		LOUDSPEAKER_AREA = new JTextArea(20, 2);
		JScrollPane scrollPane3 = new JScrollPane(LOUDSPEAKER_AREA);
		scrollPane3.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane3.setPreferredSize(new Dimension(360, 40));
		mapPane.add(scrollPane3);

		//{^PANEL
		JPanel actionPane = new JPanel();
		actionPane.setLayout(new BoxLayout(actionPane, BoxLayout.Y_AXIS));
		actionPane.setSize(120, 700);
		basePane.add(actionPane);
		
		//x
		JLabel influLabel = new JLabel("[ Effect ]");
		influLabel.setMaximumSize(new Dimension(120, 25));
		influLabel.setMinimumSize(new Dimension(120, 25));
		actionPane.add(influLabel);
		
		//Cg on/off
		lightOnOffButton = new JToggleButton("LightOn", true);
		lightOnOffButton.setMaximumSize(new Dimension(105, 25));
		lightOnOffButton.setMinimumSize(new Dimension(105, 25));
		lightOnOffButton.addActionListener(this);
		actionPane.add(lightOnOffButton);

		//~Jon/off
		orange00Button = new JToggleButton("0-0", false);
		orange00Button.setMaximumSize(new Dimension(105, 25));
		orange00Button.setMinimumSize(new Dimension(105, 25));
		orange00Button.addActionListener(this);
		actionPane.add(orange00Button);

		orange10Button = new JToggleButton("1-0", false);
		orange10Button.setMaximumSize(new Dimension(105, 25));
		orange10Button.setMinimumSize(new Dimension(105, 25));
		orange10Button.addActionListener(this);
		actionPane.add(orange10Button);

		orange20Button = new JToggleButton("2-0", false);
		orange20Button.setMaximumSize(new Dimension(105, 25));
		orange20Button.setMinimumSize(new Dimension(105, 25));
		orange20Button.addActionListener(this);
		actionPane.add(orange20Button);

		orange30Button = new JToggleButton("3-0", false);
		orange30Button.setMaximumSize(new Dimension(105, 25));
		orange30Button.setMinimumSize(new Dimension(105, 25));
		orange30Button.addActionListener(this);
		actionPane.add(orange30Button);

		orange40Button = new JToggleButton("4-0", false);
		orange40Button.setMaximumSize(new Dimension(105, 25));
		orange40Button.setMinimumSize(new Dimension(105, 25));
		orange40Button.addActionListener(this);
		actionPane.add(orange40Button);

		orange01Button = new JToggleButton("0-1", false);
		orange01Button.setMaximumSize(new Dimension(105, 25));
		orange01Button.setMinimumSize(new Dimension(105, 25));
		orange01Button.addActionListener(this);
		actionPane.add(orange01Button);

		orange11Button = new JToggleButton("1-1", false);
		orange11Button.setMaximumSize(new Dimension(105, 25));
		orange11Button.setMinimumSize(new Dimension(105, 25));
		orange11Button.addActionListener(this);
		actionPane.add(orange11Button);

		orange21Button = new JToggleButton("2-1", false);
		orange21Button.setMaximumSize(new Dimension(105, 25));
		orange21Button.setMinimumSize(new Dimension(105, 25));
		orange21Button.addActionListener(this);
		actionPane.add(orange21Button);

		orange31Button = new JToggleButton("3-1", false);
		orange31Button.setMaximumSize(new Dimension(105, 25));
		orange31Button.setMinimumSize(new Dimension(105, 25));
		orange31Button.addActionListener(this);
		actionPane.add(orange31Button);

		orange41Button = new JToggleButton("4-1", false);
		orange41Button.setMaximumSize(new Dimension(105, 25));
		orange41Button.setMinimumSize(new Dimension(105, 25));
		orange41Button.addActionListener(this);
		actionPane.add(orange41Button);

		answerButton = new JToggleButton("answer", false);
		answerButton.setMaximumSize(new Dimension(105, 25));
		answerButton.setMinimumSize(new Dimension(105, 25));
		answerButton.addActionListener(this);
		actionPane.add(answerButton);

		viewConnectButton = new JToggleButton("connect", true);
		viewConnectButton.setMaximumSize(new Dimension(105, 25));
		viewConnectButton.setMinimumSize(new Dimension(105, 25));
		viewConnectButton.addActionListener(this);
		actionPane.add(viewConnectButton);
		
		viewConnectorList.add(orange00Button);
		viewConnectorList.add(orange10Button);
		viewConnectorList.add(orange20Button);
		viewConnectorList.add(orange30Button);
		viewConnectorList.add(orange40Button);
		viewConnectorList.add(orange01Button);
		viewConnectorList.add(orange11Button);
		viewConnectorList.add(orange21Button);
		viewConnectorList.add(orange31Button);
		viewConnectorList.add(orange41Button);
		
		greatButton = new JButton("Great!");
		greatButton.setMaximumSize(new Dimension(105, 25));
		greatButton.setMinimumSize(new Dimension(105, 25));
		greatButton.addActionListener(this);
		actionPane.add(greatButton);

		mistakeButton = new JButton("Mistake!");
		mistakeButton.setMaximumSize(new Dimension(105, 25));
		mistakeButton.setMinimumSize(new Dimension(105, 25));
		mistakeButton.addActionListener(this);
		actionPane.add(mistakeButton);

		upPleasureButton = new JButton("+Pleasure");
		upPleasureButton.setMaximumSize(new Dimension(105, 25));
		upPleasureButton.setMinimumSize(new Dimension(105, 25));
		upPleasureButton.addActionListener(this);
		actionPane.add(upPleasureButton);

		downPleasureButton = new JButton("-Pleasure");
		downPleasureButton.setMaximumSize(new Dimension(105, 25));
		downPleasureButton.setMinimumSize(new Dimension(105, 25));
		downPleasureButton.addActionListener(this);
		actionPane.add(downPleasureButton);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("Orange counter");
		setSize(520, 760);
		setVisible(true);
		//setAlwaysOnTop(true);
		setLocation(500, 0);
		LOUDSPEAKER_AREA.setFocusable(true);
		
	}
	
	public static JRuleFrame getInstance() {
		return _substatnce;
	}
	
	public JAvatarMap getAvatarMap() {
		return AVATAR_MAP;
	}
	
	public JTextArea getLoudspeakerArea() {
		return LOUDSPEAKER_AREA;
	}
	
	public void setOutputCharacter(String s) {
		String sText = SOUND_RULE_AREA.getText();
		SOUND_RULE_AREA.setText(sText + s);
	}
	
	/**
	 * [ɓ͂ꂽeLXgGAɕ\܂B
	 */
	public void inputSound(SoundRuleData ruleData) {
		
		int iSize = String.valueOf(_line).length();
		setOutputCharacter("(" + "000".substring(iSize) + _line + ") " + ruleData.getContents() 
				+ " [Type=" + ruleData.getType() + " : Potential=" + ruleData.getPotential() + "]\n");
		
		_line++;
		_line = _line > 999 ? 0 : _line;
	}
	
	/**
	 * [ɓ͂ꂽʂɕ\܂B
	 */
	public void inputLight(LightRuleData ruleData) {
		//AVATAR_MAP.repaint();
	}
	
	/**
	 * w̐̃IW{^Kɉ܂
	 * @param count
	 */
	public void pushOrangeButton(int count) {
		
		if(viewConnectorList.size() < count) return;
		
		//UCg
		if(lightOnOffButton.isSelected()) lightOnOffButton.doClick();
		
		//Ă{^Όɖ߂
		for(JToggleButton button : viewConnectorList) {
			if(button.isSelected()) button.doClick();
		}
		
		int selectCount = 0;
		while(selectCount < count) {
			
			//_ɉ
			int index = new Random().nextInt(viewConnectorList.size());
			
			if(viewConnectorList.get(index).isSelected()) {
				continue;
			}
			else {
				viewConnectorList.get(index).doClick();
			}
			
			selectCount = 0;
			for(JToggleButton button : viewConnectorList) {
				if(button.isSelected()) selectCount++;
			}
		}
		
		lightOnOffButton.doClick();
	}
	
	public void actionPerformed(ActionEvent e){

		if(e.getActionCommand().equals("LightOn")) {
			lightOnOffButton.setText("LightOff");
			AVATAR_MAP.setOrangeColor(Color.DARK_GRAY);
			LightGenerator.setPotential(0);
		}
		else if(e.getActionCommand().equals("LightOff")) {
			lightOnOffButton.setText("LightOn");
			AVATAR_MAP.setOrangeColor(Color.ORANGE);
			LightGenerator.setPotential(30);
		}
		else if(e.getSource().equals(orange00Button)) {
			AVATAR_MAP.setOrange(0, 0, orange00Button.isSelected());
		}
		else if(e.getSource().equals(orange10Button)) {
			AVATAR_MAP.setOrange(1, 0, orange10Button.isSelected());
		}
		else if(e.getSource().equals(orange20Button)) {
			AVATAR_MAP.setOrange(2, 0, orange20Button.isSelected());
		}
		else if(e.getSource().equals(orange30Button)) {
			AVATAR_MAP.setOrange(3, 0, orange30Button.isSelected());
		}
		else if(e.getSource().equals(orange40Button)) {
			AVATAR_MAP.setOrange(4, 0, orange40Button.isSelected());
		}
		else if(e.getSource().equals(orange01Button)) {
			AVATAR_MAP.setOrange(0, 1, orange01Button.isSelected());
		}
		else if(e.getSource().equals(orange11Button)) {
			AVATAR_MAP.setOrange(1, 1, orange11Button.isSelected());
		}
		else if(e.getSource().equals(orange21Button)) {
			AVATAR_MAP.setOrange(2, 1, orange21Button.isSelected());
		}
		else if(e.getSource().equals(orange31Button)) {
			AVATAR_MAP.setOrange(3, 1, orange31Button.isSelected());
		}
		else if(e.getSource().equals(orange41Button)) {
			AVATAR_MAP.setOrange(4, 1, orange41Button.isSelected());
		}
		else if(e.getSource().equals(answerButton)) {
			ANSWER.setSwitch(answerButton.isSelected());
		}
		else if(e.getSource().equals(viewConnectButton)) {
			VIEW_CONNECTER.setSwitch(viewConnectButton.isSelected());
		}
		else if(e.getSource().equals(greatButton)) {
			GreatSoundOutputer.getInstance().execute();
		}
		else if(e.getSource().equals(mistakeButton)) {
			MistakeSoundOutputer.getInstance().execute();
		}
		else if(e.getSource().equals(upPleasureButton)) {
			UpPleasureOutputer.getInstance().execute();
		}
		else if(e.getSource().equals(downPleasureButton)) {
			DownPleasureOutputer.getInstance().execute();
		}
		
		AVATAR_MAP.repaint();
	}
	
}
