package jp.co.celestee.ai.main;

import jp.co.celestee.ai.core.factory.PhysicalDesireFactory;
import jp.co.celestee.ai.interfaces.body.id.BodyWalkId;
import jp.co.celestee.ai.interfaces.characterin.id.ListenId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutEightId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutEqualsId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutFiveId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutFourId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutNineId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutOneId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutSevenId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutSixId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutTenId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutThreeId;
import jp.co.celestee.ai.interfaces.characterout.id.CharacterOutTwoId;
import jp.co.celestee.ai.interfaces.constant.PhysicalDesireConst;
import jp.co.celestee.ai.interfaces.eye.EyeOutputId;
import jp.co.celestee.ai.interfaces.status.JStatusFrame;
import jp.co.celestee.ai.interfaces.status.StatusWatcher;

public class MainClass {

	public static void main(String args[]) {
		
		//~̓o^
		PhysicalDesireFactory.createAndManage(new CharacterOutOneId(), PhysicalDesireConst.ONE_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutTwoId(), PhysicalDesireConst.TWO_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutThreeId(), PhysicalDesireConst.THREE_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutFourId(), PhysicalDesireConst.FOUR_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutFiveId(), PhysicalDesireConst.FIVE_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutSixId(), PhysicalDesireConst.SIX_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutSevenId(), PhysicalDesireConst.SEVEN_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutEightId(), PhysicalDesireConst.EIGHT_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutNineId(), PhysicalDesireConst.NINE_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutTenId(), PhysicalDesireConst.TEN_SOUND_DESIRE);
		PhysicalDesireFactory.createAndManage(new CharacterOutEqualsId(), PhysicalDesireConst.EQUALS_DESIRE);
		PhysicalDesireFactory.createAndManage(new BodyWalkId(), PhysicalDesireConst.WALK_DESIRE);
		PhysicalDesireFactory.createAndManage(new ListenId(), PhysicalDesireConst.LISTEN_DESIRE);
		PhysicalDesireFactory.createAndManage(new EyeOutputId(), PhysicalDesireConst.ADD_DESIRE);

		//~̓̃vCXg[
		//List<Long> installList = new ArrayList<Long>();
		//installList.add(PhysicalDesireConst.WALK_DESIRE);
		//installList.add(PhysicalDesireConst.TURN_LEFT_DESIRE);
		//PhysicalDesirePreInstaller.setPhysicalDesireNerveList(installList);
		
		//̕I~ʒmĂ
		//List<AbstractPhysicalSensibleSignal> psSignalList = BodySubstance.getInstance().getPhysicalSensibleSignalList();
		//try {
		//	EntranceReaction.startReaction(null, null, psSignalList);
		//} catch (CloneNotSupportedException e) {
		//	e.printStackTrace();
		//}

		//AĨXe[^XĎ
		new JStatusFrame();
		StatusWatcher statusWatcher = new StatusWatcher();
		statusWatcher.start();
		
		SmallWorldBuilder.buildWorld();
		
	}
}
