package jp.co.celestee.ai.main;

import jp.co.celestee.ai.interfaces.body.BodySubstance;
import jp.co.celestee.ai.interfaces.characterin.CharacterInSubstance;
import jp.co.celestee.ai.interfaces.image.ImageSubstance;
import jp.co.celestee.external.object.Answer;
import jp.co.celestee.external.object.LightGenerator;
import jp.co.celestee.external.object.Loudspeaker;
import jp.co.celestee.external.object.ViewConnector;
import jp.co.celestee.external.rule.RuleIF;
import jp.co.celestee.external.rule.RuleManager;
import jp.co.celestee.external.rule.dinamic.DynamicRule;
import jp.co.celestee.external.rule.light.LightRule;
import jp.co.celestee.external.rule.sound.SoundRule;
import jp.co.celestee.external.virtual.JRuleFrame;

/**
 * K͐EgݗĂ܂B
 * @author celestee
 *
 */
public class SmallWorldBuilder {

	public static void buildWorld() {
		
		JRuleFrame frame = JRuleFrame.getInstance();
		
		//geLXgGAƊ֘At
		Loudspeaker loudSpeaker = Loudspeaker.getInstance();
		loudSpeaker.setMonitor(frame.getLoudspeakerArea());
		
		//̔ݒ肷
		LightGenerator lightGeneraotor = new LightGenerator();
		
		//ăQ[@ݒ肷
		Answer answer = Answer.getInstance();
		
		//}CN̉摜ɕϊ@ݒ肷
		ViewConnector mike = ViewConnector.getInstance();
		mike.setSoundViewer(frame);
		
		//[Kpi[j
		RuleIF characterRule = RuleManager.getInstance().getRule(SoundRule.SOUND_RULE);
		characterRule.entry(CharacterInSubstance.getInstance());
		characterRule.entry(frame);
		characterRule.entry(answer);
		characterRule.entry(mike);
		
		//[Kpi摜[j
		RuleIF imageRule = RuleManager.getInstance().getRule(LightRule.LIGHT_RULE);
		imageRule.entry(ImageSubstance.getInstance());
		imageRule.entry(answer);
		imageRule.entry(frame);

		//[KpiGo[j
		RuleIF dynamicRule = RuleManager.getInstance().getRule(DynamicRule.DYNAMIC_RULE);
		dynamicRule.entry(BodySubstance.getInstance());

		frame.repaint();
		
		loudSpeaker.start();
		lightGeneraotor.start();
		
	}
}
